Bugzilla will be upgraded to version 5.0. The upgrade date is tentatively scheduled for 2 December 2018, pending final testing and feedback.
Bug 1265885 - Review Request: zeal - Offline documentation browser inspired by Dash
Review Request: zeal - Offline documentation browser inspired by Dash
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jackson Isaac
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-09-24 00:25 EDT by Michel Alexandre Salim
Modified: 2015-11-01 16:51 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-31 22:36:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jacksonisaac2008: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2015-09-24 00:25:21 EDT
Spec URL: https://salimma.fedorapeople.org/specs/devtools/zeal.spec
SRPM URL: https://salimma.fedorapeople.org/specs/devtools/zeal-0.1.1-1.fc23.src.rpm
Description:
Zeal is a simple offline documentation browser inspired by Dash.

Fedora Account System Username: salimma
Comment 1 Michel Alexandre Salim 2015-09-24 00:28:27 EDT
COPR builds: https://copr.fedoraproject.org/coprs/salimma/zeal/
Comment 2 Jackson Isaac 2015-10-01 08:16:02 EDT
In Source0 is the '#/%{name}-%{version}.tar.gz' (Git tag) necessary ? The release tarball and url with tag link/points to the same file. 

There are few issues related to licensing and 3rd party libraries being included in the source.

I tried running zeal and clicked on open url but nothing opened up. I don't know if that if the desired behavior or I did something wrong.

Other than that looks good to me.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Sources used to build the package match the upstream source, as provided
  in the spec URL.
  Note: Upstream MD5sum check error, diff is in /home/jacksonisaac/fedora-
  review/1265885-zeal/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL
- update-desktop-database is invoked in %post and %postun if package
  contains desktop file(s) with a MimeType: entry.
  Note: desktop file(s) with MimeType entry in zeal
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
  database


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Unknown or generated". 50 files have unknown
     license. Detailed output of licensecheck in /home/jacksonisaac/fedora-
     review/1265885-zeal/licensecheck.txt

==>  Files under src/3rdparty/qxtglobalshortcut/ are licensed with BSD 3 Clause by The libQtx project and also GPL 3 by the zeal project.
Refer https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios

[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.

==>  There is a fork of third party package under src/3rdparty/. This is also a reason for the licensing issue mentioned above.
Refer https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Licensing
If possible, it can be packaged as a subpackage. Awaiting reply from the contributor for further clarification.

[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in zeal
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

==>  %check is missing. Awaiting clarification from contributor if %check is required or not.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: zeal-0.1.1-1.fc22.x86_64.rpm
          zeal-0.1.1-1.fc22.src.rpm
zeal.x86_64: W: no-manual-page-for-binary zeal
zeal.src:11: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 11)
2 packages and 0 specfiles checked; 0 errors, 2 warnings.


==> Couldn't find the zeal.src file. Can you please look into this and fix if possible.



Rpmlint (debuginfo)
-------------------
Checking: zeal-debuginfo-0.1.1-1.fc22.x86_64.rpm
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.rcc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.rcc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.ui
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.ui
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.moc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.moc
1 packages and 0 specfiles checked; 0 errors, 6 warnings.





Rpmlint (installed packages)
----------------------------
zeal.x86_64: W: no-manual-page-for-binary zeal
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.rcc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.rcc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.ui
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.ui
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.moc
zeal-debuginfo.x86_64: W: hidden-file-or-dir /usr/src/debug/zeal-0.1.1/.moc
2 packages and 0 specfiles checked; 0 errors, 7 warnings.



Requires
--------
zeal (rpmlib, GLIBC filtered):
    /bin/sh
    hicolor-icon-theme
    libGL.so.1()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5Gui.so.5()(64bit)
    libQt5Network.so.5()(64bit)
    libQt5Sql.so.5()(64bit)
    libQt5WebKit.so.5()(64bit)
    libQt5WebKitWidgets.so.5()(64bit)
    libQt5Widgets.so.5()(64bit)
    libX11.so.6()(64bit)
    libarchive.so.13()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
zeal:
    application()
    application(zeal.desktop)
    mimehandler(x-scheme-handler/dash)
    mimehandler(x-scheme-handler/dash-plugin)
    zeal
    zeal(x86-64)



Source checksums
----------------
https://github.com/zealdocs/zeal/archive/v0.1.1.tar.gz#/zeal-0.1.1.tar.gz :
  CHECKSUM(SHA256) this package     : f4e959f9bc66a6e350ee8a33d34695379633432d103db9776c0c7a76cbc5a9d6
  CHECKSUM(SHA256) upstream package : 910a6ba4d2bf03fe5f5d4e5b9790b9f8148443035a2fb20de26ecc398ee5ae40
diff -r also reports differences


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1265885
Buildroot used: fedora-22-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6



Attaching few files mentioned in review.txt that were created:
1. diff.txt

Binary files /home/jacksonisaac/fedora-review/1265885-zeal/upstream-unpacked/Source0/zeal-0.1.1/src/resources/zeal.ico and /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src/resources/zeal.ico differ
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src/resources: zeal.qrc
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src: src.pro
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src: ui
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src: util
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1/src: zeal.desktop
Only in /home/jacksonisaac/fedora-review/1265885-zeal/srpm-unpacked/zeal-0.1.1.tar.gz-extract/zeal-0.1.1: zeal.pro
Only in /home/jacksonisaac/fedora-review/1265885-zeal/upstream-unpacked/Source0: zeal-0.1.1.tar.gz


2. licensecheck.txt


BSD (3 clause)
--------------
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobal.h
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut.cpp
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut.h
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut_mac.cpp
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut_p.h
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut_win.cpp
zeal-0.1.1/src/3rdparty/qxtglobalshortcut/qxtglobalshortcut_x11.cpp

Unknown or generated
--------------------
zeal-0.1.1/src/core/application.cpp
zeal-0.1.1/src/core/application.h
zeal-0.1.1/src/core/extractor.cpp
zeal-0.1.1/src/core/extractor.h
zeal-0.1.1/src/core/settings.cpp
zeal-0.1.1/src/core/settings.h
zeal-0.1.1/src/main.cpp
zeal-0.1.1/src/registry/docset.cpp
zeal-0.1.1/src/registry/docset.h
zeal-0.1.1/src/registry/docsetinfo.cpp
zeal-0.1.1/src/registry/docsetinfo.h
zeal-0.1.1/src/registry/docsetmetadata.cpp
zeal-0.1.1/src/registry/docsetmetadata.h
zeal-0.1.1/src/registry/docsetregistry.cpp
zeal-0.1.1/src/registry/docsetregistry.h
zeal-0.1.1/src/registry/listmodel.cpp
zeal-0.1.1/src/registry/listmodel.h
zeal-0.1.1/src/registry/rename.sh
zeal-0.1.1/src/registry/searchmodel.cpp
zeal-0.1.1/src/registry/searchmodel.h
zeal-0.1.1/src/registry/searchquery.cpp
zeal-0.1.1/src/registry/searchquery.h
zeal-0.1.1/src/registry/searchresult.cpp
zeal-0.1.1/src/registry/searchresult.h
zeal-0.1.1/src/ui/aboutdialog.cpp
zeal-0.1.1/src/ui/aboutdialog.h
zeal-0.1.1/src/ui/docsetlistitemdelegate.cpp
zeal-0.1.1/src/ui/docsetlistitemdelegate.h
zeal-0.1.1/src/ui/mainwindow.cpp
zeal-0.1.1/src/ui/mainwindow.h
zeal-0.1.1/src/ui/networkaccessmanager.cpp
zeal-0.1.1/src/ui/networkaccessmanager.h
zeal-0.1.1/src/ui/progressitemdelegate.cpp
zeal-0.1.1/src/ui/progressitemdelegate.h
zeal-0.1.1/src/ui/searchitemdelegate.cpp
zeal-0.1.1/src/ui/searchitemdelegate.h
zeal-0.1.1/src/ui/searchitemstyle.cpp
zeal-0.1.1/src/ui/searchitemstyle.h
zeal-0.1.1/src/ui/settingsdialog.cpp
zeal-0.1.1/src/ui/settingsdialog.h
zeal-0.1.1/src/ui/widgets/searchablewebview.cpp
zeal-0.1.1/src/ui/widgets/searchablewebview.h
zeal-0.1.1/src/ui/widgets/searchedit.cpp
zeal-0.1.1/src/ui/widgets/searchedit.h
zeal-0.1.1/src/ui/widgets/shortcutedit.cpp
zeal-0.1.1/src/ui/widgets/shortcutedit.h
zeal-0.1.1/src/ui/widgets/webview.cpp
zeal-0.1.1/src/ui/widgets/webview.h
zeal-0.1.1/src/util/version.cpp
zeal-0.1.1/src/util/version.h
Comment 3 Michel Alexandre Salim 2015-10-01 10:38:27 EDT
(In reply to Jackson Isaac from comment #2)
> In Source0 is the '#/%{name}-%{version}.tar.gz' (Git tag) necessary ? The
> release tarball and url with tag link/points to the same file. 
> 
Yes. You can try doing spectool -gf on the spec file without the #/%{name}-%{version}.tar.gz -- you'll get v%{version}.tar.gz as the file name. They do not point to the same file. There's a mailing list discussion about this (how best to get properly-named source tarballs out of Github).

> There are few issues related to licensing and 3rd party libraries being
> included in the source.
> 
I don't think there's an issue with licensing (apart from needing to update the license info), but inclusion of 3rd party lib is indeed bad, let me see if I can build zeal against the upstream libqxt instead.

> I tried running zeal and clicked on open url but nothing opened up. I don't
> know if that if the desired behavior or I did something wrong.
> 
Hmm, what Open URL? You need to go to File->Options, switch to the Docsets tab and install something.
Comment 4 Michel Alexandre Salim 2015-10-14 13:26:36 EDT
Per FESCo meeting minutes, bundling is now allowed provided the package does not work without, upstream has been contacted (and the conversation recorded) and the package metadata shows what is bundled:

https://lists.fedoraproject.org/pipermail/devel/2015-October/215429.html
https://paste.fedoraproject.org/276064/44243383/

Package is now updated (plus adding the license info for qxt files)

Spec URL: https://salimma.fedorapeople.org/specs/devtools/zeal.spec
SRPM URL: https://salimma.fedorapeople.org/specs/devtools/zeal-0.1.1-2.fc23.src.rpm

COPR builds:
https://copr.fedoraproject.org/coprs/salimma/zeal/builds/
Comment 5 Jackson Isaac 2015-10-15 12:53:17 EDT
Hi,

Looks good to me. Review + from me. Thank you for adding relevant links of mail discussions and upstream issue link in the spec file.
Comment 6 Michel Alexandre Salim 2015-10-15 12:59:12 EDT
Excellent, thanks!
Comment 7 Fedora Update System 2015-10-16 03:07:19 EDT
zeal-0.1.1-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-c4ab19fa91
Comment 8 Fedora Update System 2015-10-16 15:51:20 EDT
zeal-0.1.1-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update zeal'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-c4ab19fa91
Comment 9 Fedora Update System 2015-10-17 20:53:05 EDT
zeal-0.1.1-2.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update zeal'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-758f0f8d38
Comment 10 Fedora Update System 2015-10-31 22:36:30 EDT
zeal-0.1.1-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2015-11-01 16:51:55 EST
zeal-0.1.1-2.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.